import{S as Qt,i as Wt,s as Zt,e as n,k as p,w as f,t as m,M as es,c as o,d as t,m as h,a as l,x as u,h as c,b as r,G as s,g as i,y as g,L as ts,q as d,o as v,B as w,v as ss}from"../../chunks/vendor-hf-doc-builder.js";import{I as ge}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as te}from"../../chunks/CodeBlock-hf-doc-builder.js";function as(xt){let _,de,$,E,se,H,Fe,ae,Xe,ve,j,ne,Je,Ke,z,Qe,We,we,b,I,oe,R,Ze,le,et,_e,X,tt,$e,L,je,J,st,be,G,ye,K,at,xe,V,ke,Q,nt,Ee,Y,Ie,P,ot,ie,lt,it,Pe,S,rt,W,pt,mt,Se,y,A,re,M,ht,pe,ct,Ae,Z,ft,qe,U,Ne,q,ut,B,gt,dt,Te,x,N,me,D,vt,he,wt,Ce,T,_t,ee,$t,jt,He,k,C,ce,O,bt,fe,yt,ze,F,Re;return H=new ge({}),R=new ge({}),L=new te({props:{code:`import timm
model = timm.create_model('inception_v4', pretrained=True)
model.eval()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> timm
<span class="hljs-meta">&gt;&gt;&gt; </span>model = timm.create_model(<span class="hljs-string">&#x27;inception_v4&#x27;</span>, pretrained=<span class="hljs-literal">True</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model.<span class="hljs-built_in">eval</span>()`}}),G=new te({props:{code:`import urllib
from PIL import Image
from timm.data import resolve_data_config
from timm.data.transforms_factory import create_transform

config = resolve_data_config({}, model=model)
transform = create_transform(**config)

url, filename = ("https://github.com/pytorch/hub/raw/master/images/dog.jpg", "dog.jpg")
urllib.request.urlretrieve(url, filename)
img = Image.open(filename).convert('RGB')
tensor = transform(img).unsqueeze(0) # transform and add batch dimension`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> urllib
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> timm.data <span class="hljs-keyword">import</span> resolve_data_config
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> timm.data.transforms_factory <span class="hljs-keyword">import</span> create_transform

<span class="hljs-meta">&gt;&gt;&gt; </span>config = resolve_data_config({}, model=model)
<span class="hljs-meta">&gt;&gt;&gt; </span>transform = create_transform(**config)

<span class="hljs-meta">&gt;&gt;&gt; </span>url, filename = (<span class="hljs-string">&quot;https://github.com/pytorch/hub/raw/master/images/dog.jpg&quot;</span>, <span class="hljs-string">&quot;dog.jpg&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>urllib.request.urlretrieve(url, filename)
<span class="hljs-meta">&gt;&gt;&gt; </span>img = Image.<span class="hljs-built_in">open</span>(filename).convert(<span class="hljs-string">&#x27;RGB&#x27;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tensor = transform(img).unsqueeze(<span class="hljs-number">0</span>) <span class="hljs-comment"># transform and add batch dimension</span>`}}),V=new te({props:{code:`import torch
with torch.no_grad():
    out = model(tensor)
probabilities = torch.nn.functional.softmax(out[0], dim=0)
print(probabilities.shape)
# prints: torch.Size([1000])`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    out = model(tensor)
<span class="hljs-meta">&gt;&gt;&gt; </span>probabilities = torch.nn.functional.softmax(out[<span class="hljs-number">0</span>], dim=<span class="hljs-number">0</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(probabilities.shape)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># prints: torch.Size([1000])</span>`}}),Y=new te({props:{code:`# Get imagenet class mappings
url, filename = ("https://raw.githubusercontent.com/pytorch/hub/master/imagenet_classes.txt", "imagenet_classes.txt")
urllib.request.urlretrieve(url, filename) 
with open("imagenet_classes.txt", "r") as f:
    categories = [s.strip() for s in f.readlines()]

# Print top categories per image
top5_prob, top5_catid = torch.topk(probabilities, 5)
for i in range(top5_prob.size(0)):
    print(categories[top5_catid[i]], top5_prob[i].item())
# prints class names and probabilities like:
# [('Samoyed', 0.6425196528434753), ('Pomeranian', 0.04062102362513542), ('keeshond', 0.03186424449086189), ('white wolf', 0.01739676296710968), ('Eskimo dog', 0.011717947199940681)]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Get imagenet class mappings</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>url, filename = (<span class="hljs-string">&quot;https://raw.githubusercontent.com/pytorch/hub/master/imagenet_classes.txt&quot;</span>, <span class="hljs-string">&quot;imagenet_classes.txt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>urllib.request.urlretrieve(url, filename) 
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> <span class="hljs-built_in">open</span>(<span class="hljs-string">&quot;imagenet_classes.txt&quot;</span>, <span class="hljs-string">&quot;r&quot;</span>) <span class="hljs-keyword">as</span> f:
<span class="hljs-meta">... </span>    categories = [s.strip() <span class="hljs-keyword">for</span> s <span class="hljs-keyword">in</span> f.readlines()]

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Print top categories per image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>top5_prob, top5_catid = torch.topk(probabilities, <span class="hljs-number">5</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> i <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(top5_prob.size(<span class="hljs-number">0</span>)):
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(categories[top5_catid[i]], top5_prob[i].item())
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># prints class names and probabilities like:</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># [(&#x27;Samoyed&#x27;, 0.6425196528434753), (&#x27;Pomeranian&#x27;, 0.04062102362513542), (&#x27;keeshond&#x27;, 0.03186424449086189), (&#x27;white wolf&#x27;, 0.01739676296710968), (&#x27;Eskimo dog&#x27;, 0.011717947199940681)]</span>`}}),M=new ge({}),U=new te({props:{code:"model = timm.create_model('inception_v4', pretrained=True, num_classes=NUM_FINETUNE_CLASSES)",highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>model = timm.create_model(<span class="hljs-string">&#x27;inception_v4&#x27;</span>, pretrained=<span class="hljs-literal">True</span>, num_classes=NUM_FINETUNE_CLASSES)'}}),D=new ge({}),O=new ge({}),F=new te({props:{code:`@misc{szegedy2016inceptionv4,
      title={Inception-v4, Inception-ResNet and the Impact of Residual Connections on Learning}, 
      author={Christian Szegedy and Sergey Ioffe and Vincent Vanhoucke and Alex Alemi},
      year={2016},
      eprint={1602.07261},
      archivePrefix={arXiv},
      primaryClass={cs.CV}
}`,highlighted:`<span class="language-xml">@misc</span><span class="hljs-template-variable">{szegedy2016inceptionv4,
      title={Inception-v4, Inception-ResNet and the Impact of Residual Connections on Learning}</span><span class="language-xml">, 
      author=</span><span class="hljs-template-variable">{Christian Szegedy and Sergey Ioffe and Vincent Vanhoucke and Alex Alemi}</span><span class="language-xml">,
      year=</span><span class="hljs-template-variable">{2016}</span><span class="language-xml">,
      eprint=</span><span class="hljs-template-variable">{1602.07261}</span><span class="language-xml">,
      archivePrefix=</span><span class="hljs-template-variable">{arXiv}</span><span class="language-xml">,
      primaryClass=</span><span class="hljs-template-variable">{cs.CV}</span><span class="language-xml">
}</span>`}}),{c(){_=n("meta"),de=p(),$=n("h1"),E=n("a"),se=n("span"),f(H.$$.fragment),Fe=p(),ae=n("span"),Xe=m("Inception v4"),ve=p(),j=n("p"),ne=n("strong"),Je=m("Inception-v4"),Ke=m(" is a convolutional neural network architecture that builds on previous iterations of the Inception family by simplifying the architecture and using more inception modules than "),z=n("a"),Qe=m("Inception-v3"),We=m("."),we=p(),b=n("h2"),I=n("a"),oe=n("span"),f(R.$$.fragment),Ze=p(),le=n("span"),et=m("How do I use this model on an image?"),_e=p(),X=n("p"),tt=m("To load a pretrained model:"),$e=p(),f(L.$$.fragment),je=p(),J=n("p"),st=m("To load and preprocess the image:"),be=p(),f(G.$$.fragment),ye=p(),K=n("p"),at=m("To get the model predictions:"),xe=p(),f(V.$$.fragment),ke=p(),Q=n("p"),nt=m("To get the top-5 predictions class names:"),Ee=p(),f(Y.$$.fragment),Ie=p(),P=n("p"),ot=m("Replace the model name with the variant you want to use, e.g. "),ie=n("code"),lt=m("inception_v4"),it=m(". You can find the IDs in the model summaries at the top of this page."),Pe=p(),S=n("p"),rt=m("To extract image features with this model, follow the "),W=n("a"),pt=m("timm feature extraction examples"),mt=m(", just change the name of the model you want to use."),Se=p(),y=n("h2"),A=n("a"),re=n("span"),f(M.$$.fragment),ht=p(),pe=n("span"),ct=m("How do I finetune this model?"),Ae=p(),Z=n("p"),ft=m("You can finetune any of the pre-trained models just by changing the classifier (the last layer)."),qe=p(),f(U.$$.fragment),Ne=p(),q=n("p"),ut=m("To finetune on your own dataset, you have to write a training loop or adapt "),B=n("a"),gt=m(`timm\u2019s training
script`),dt=m(" to use your dataset."),Te=p(),x=n("h2"),N=n("a"),me=n("span"),f(D.$$.fragment),vt=p(),he=n("span"),wt=m("How do I train this model?"),Ce=p(),T=n("p"),_t=m("You can follow the "),ee=n("a"),$t=m("timm recipe scripts"),jt=m(" for training a new model afresh."),He=p(),k=n("h2"),C=n("a"),ce=n("span"),f(O.$$.fragment),bt=p(),fe=n("span"),yt=m("Citation"),ze=p(),f(F.$$.fragment),this.h()},l(e){const a=es('[data-svelte="svelte-1phssyn"]',document.head);_=o(a,"META",{name:!0,content:!0}),a.forEach(t),de=h(e),$=o(e,"H1",{class:!0});var Le=l($);E=o(Le,"A",{id:!0,class:!0,href:!0});var kt=l(E);se=o(kt,"SPAN",{});var Et=l(se);u(H.$$.fragment,Et),Et.forEach(t),kt.forEach(t),Fe=h(Le),ae=o(Le,"SPAN",{});var It=l(ae);Xe=c(It,"Inception v4"),It.forEach(t),Le.forEach(t),ve=h(e),j=o(e,"P",{});var ue=l(j);ne=o(ue,"STRONG",{});var Pt=l(ne);Je=c(Pt,"Inception-v4"),Pt.forEach(t),Ke=c(ue," is a convolutional neural network architecture that builds on previous iterations of the Inception family by simplifying the architecture and using more inception modules than "),z=o(ue,"A",{href:!0,rel:!0});var St=l(z);Qe=c(St,"Inception-v3"),St.forEach(t),We=c(ue,"."),ue.forEach(t),we=h(e),b=o(e,"H2",{class:!0});var Ge=l(b);I=o(Ge,"A",{id:!0,class:!0,href:!0});var At=l(I);oe=o(At,"SPAN",{});var qt=l(oe);u(R.$$.fragment,qt),qt.forEach(t),At.forEach(t),Ze=h(Ge),le=o(Ge,"SPAN",{});var Nt=l(le);et=c(Nt,"How do I use this model on an image?"),Nt.forEach(t),Ge.forEach(t),_e=h(e),X=o(e,"P",{});var Tt=l(X);tt=c(Tt,"To load a pretrained model:"),Tt.forEach(t),$e=h(e),u(L.$$.fragment,e),je=h(e),J=o(e,"P",{});var Ct=l(J);st=c(Ct,"To load and preprocess the image:"),Ct.forEach(t),be=h(e),u(G.$$.fragment,e),ye=h(e),K=o(e,"P",{});var Ht=l(K);at=c(Ht,"To get the model predictions:"),Ht.forEach(t),xe=h(e),u(V.$$.fragment,e),ke=h(e),Q=o(e,"P",{});var zt=l(Q);nt=c(zt,"To get the top-5 predictions class names:"),zt.forEach(t),Ee=h(e),u(Y.$$.fragment,e),Ie=h(e),P=o(e,"P",{});var Ve=l(P);ot=c(Ve,"Replace the model name with the variant you want to use, e.g. "),ie=o(Ve,"CODE",{});var Rt=l(ie);lt=c(Rt,"inception_v4"),Rt.forEach(t),it=c(Ve,". You can find the IDs in the model summaries at the top of this page."),Ve.forEach(t),Pe=h(e),S=o(e,"P",{});var Ye=l(S);rt=c(Ye,"To extract image features with this model, follow the "),W=o(Ye,"A",{href:!0});var Lt=l(W);pt=c(Lt,"timm feature extraction examples"),Lt.forEach(t),mt=c(Ye,", just change the name of the model you want to use."),Ye.forEach(t),Se=h(e),y=o(e,"H2",{class:!0});var Me=l(y);A=o(Me,"A",{id:!0,class:!0,href:!0});var Gt=l(A);re=o(Gt,"SPAN",{});var Vt=l(re);u(M.$$.fragment,Vt),Vt.forEach(t),Gt.forEach(t),ht=h(Me),pe=o(Me,"SPAN",{});var Yt=l(pe);ct=c(Yt,"How do I finetune this model?"),Yt.forEach(t),Me.forEach(t),Ae=h(e),Z=o(e,"P",{});var Mt=l(Z);ft=c(Mt,"You can finetune any of the pre-trained models just by changing the classifier (the last layer)."),Mt.forEach(t),qe=h(e),u(U.$$.fragment,e),Ne=h(e),q=o(e,"P",{});var Ue=l(q);ut=c(Ue,"To finetune on your own dataset, you have to write a training loop or adapt "),B=o(Ue,"A",{href:!0,rel:!0});var Ut=l(B);gt=c(Ut,`timm\u2019s training
script`),Ut.forEach(t),dt=c(Ue," to use your dataset."),Ue.forEach(t),Te=h(e),x=o(e,"H2",{class:!0});var Be=l(x);N=o(Be,"A",{id:!0,class:!0,href:!0});var Bt=l(N);me=o(Bt,"SPAN",{});var Dt=l(me);u(D.$$.fragment,Dt),Dt.forEach(t),Bt.forEach(t),vt=h(Be),he=o(Be,"SPAN",{});var Ot=l(he);wt=c(Ot,"How do I train this model?"),Ot.forEach(t),Be.forEach(t),Ce=h(e),T=o(e,"P",{});var De=l(T);_t=c(De,"You can follow the "),ee=o(De,"A",{href:!0});var Ft=l(ee);$t=c(Ft,"timm recipe scripts"),Ft.forEach(t),jt=c(De," for training a new model afresh."),De.forEach(t),He=h(e),k=o(e,"H2",{class:!0});var Oe=l(k);C=o(Oe,"A",{id:!0,class:!0,href:!0});var Xt=l(C);ce=o(Xt,"SPAN",{});var Jt=l(ce);u(O.$$.fragment,Jt),Jt.forEach(t),Xt.forEach(t),bt=h(Oe),fe=o(Oe,"SPAN",{});var Kt=l(fe);yt=c(Kt,"Citation"),Kt.forEach(t),Oe.forEach(t),ze=h(e),u(F.$$.fragment,e),this.h()},h(){r(_,"name","hf:doc:metadata"),r(_,"content",JSON.stringify(ns)),r(E,"id","inception-v4"),r(E,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(E,"href","#inception-v4"),r($,"class","relative group"),r(z,"href","https://paperswithcode.com/method/inception-v3"),r(z,"rel","nofollow"),r(I,"id","how-do-i-use-this-model-on-an-image"),r(I,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(I,"href","#how-do-i-use-this-model-on-an-image"),r(b,"class","relative group"),r(W,"href","../feature_extraction"),r(A,"id","how-do-i-finetune-this-model"),r(A,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(A,"href","#how-do-i-finetune-this-model"),r(y,"class","relative group"),r(B,"href","https://github.com/rwightman/pytorch-image-models/blob/master/train.py"),r(B,"rel","nofollow"),r(N,"id","how-do-i-train-this-model"),r(N,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(N,"href","#how-do-i-train-this-model"),r(x,"class","relative group"),r(ee,"href","../scripts"),r(C,"id","citation"),r(C,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(C,"href","#citation"),r(k,"class","relative group")},m(e,a){s(document.head,_),i(e,de,a),i(e,$,a),s($,E),s(E,se),g(H,se,null),s($,Fe),s($,ae),s(ae,Xe),i(e,ve,a),i(e,j,a),s(j,ne),s(ne,Je),s(j,Ke),s(j,z),s(z,Qe),s(j,We),i(e,we,a),i(e,b,a),s(b,I),s(I,oe),g(R,oe,null),s(b,Ze),s(b,le),s(le,et),i(e,_e,a),i(e,X,a),s(X,tt),i(e,$e,a),g(L,e,a),i(e,je,a),i(e,J,a),s(J,st),i(e,be,a),g(G,e,a),i(e,ye,a),i(e,K,a),s(K,at),i(e,xe,a),g(V,e,a),i(e,ke,a),i(e,Q,a),s(Q,nt),i(e,Ee,a),g(Y,e,a),i(e,Ie,a),i(e,P,a),s(P,ot),s(P,ie),s(ie,lt),s(P,it),i(e,Pe,a),i(e,S,a),s(S,rt),s(S,W),s(W,pt),s(S,mt),i(e,Se,a),i(e,y,a),s(y,A),s(A,re),g(M,re,null),s(y,ht),s(y,pe),s(pe,ct),i(e,Ae,a),i(e,Z,a),s(Z,ft),i(e,qe,a),g(U,e,a),i(e,Ne,a),i(e,q,a),s(q,ut),s(q,B),s(B,gt),s(q,dt),i(e,Te,a),i(e,x,a),s(x,N),s(N,me),g(D,me,null),s(x,vt),s(x,he),s(he,wt),i(e,Ce,a),i(e,T,a),s(T,_t),s(T,ee),s(ee,$t),s(T,jt),i(e,He,a),i(e,k,a),s(k,C),s(C,ce),g(O,ce,null),s(k,bt),s(k,fe),s(fe,yt),i(e,ze,a),g(F,e,a),Re=!0},p:ts,i(e){Re||(d(H.$$.fragment,e),d(R.$$.fragment,e),d(L.$$.fragment,e),d(G.$$.fragment,e),d(V.$$.fragment,e),d(Y.$$.fragment,e),d(M.$$.fragment,e),d(U.$$.fragment,e),d(D.$$.fragment,e),d(O.$$.fragment,e),d(F.$$.fragment,e),Re=!0)},o(e){v(H.$$.fragment,e),v(R.$$.fragment,e),v(L.$$.fragment,e),v(G.$$.fragment,e),v(V.$$.fragment,e),v(Y.$$.fragment,e),v(M.$$.fragment,e),v(U.$$.fragment,e),v(D.$$.fragment,e),v(O.$$.fragment,e),v(F.$$.fragment,e),Re=!1},d(e){t(_),e&&t(de),e&&t($),w(H),e&&t(ve),e&&t(j),e&&t(we),e&&t(b),w(R),e&&t(_e),e&&t(X),e&&t($e),w(L,e),e&&t(je),e&&t(J),e&&t(be),w(G,e),e&&t(ye),e&&t(K),e&&t(xe),w(V,e),e&&t(ke),e&&t(Q),e&&t(Ee),w(Y,e),e&&t(Ie),e&&t(P),e&&t(Pe),e&&t(S),e&&t(Se),e&&t(y),w(M),e&&t(Ae),e&&t(Z),e&&t(qe),w(U,e),e&&t(Ne),e&&t(q),e&&t(Te),e&&t(x),w(D),e&&t(Ce),e&&t(T),e&&t(He),e&&t(k),w(O),e&&t(ze),w(F,e)}}}const ns={local:"inception-v4",sections:[{local:"how-do-i-use-this-model-on-an-image",title:"How do I use this model on an image?"},{local:"how-do-i-finetune-this-model",title:"How do I finetune this model?"},{local:"how-do-i-train-this-model",title:"How do I train this model?"},{local:"citation",title:"Citation"}],title:"Inception v4"};function os(xt){return ss(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ps extends Qt{constructor(_){super();Wt(this,_,os,as,Zt,{})}}export{ps as default,ns as metadata};
